
#include <conio.h>
#include <stdio.h>
#include <io.h>
#include <alloc.h>
#include <fcntl.h>
#include <process.h>
#include <sys\stat.h>

#include <math.h>

#include "unephjpl.h"
#include "unforfun.h"

 void toobtainfmus ( )
 {
   /* for de200 model only
     from introduction aux ephemerides astronomiques  france */
   double systemofmasses[12] =
                   {          0.0 ,         /* nullo */
                        6023600.000,        /* the Mercury iau 1976*/
                        408523.500,         /* the Venus iau 1976 */
                        332946.0379476187,  /* the Earth only de200 */
                       3098710.000,         /* the Mars iau 1976 */
                          1047.350,         /* the Jupiter  de200 */
                          3498.000,         /* the Saturn de200 */
                         22960.000,         /* the Uranus de200 */
                         19314.000,         /* the Neptune */
                     130000000.000,         /* the Pluto de200 */
                      27068708.7489041655,  /* the Moon only le200 */
                             1.0  } ;       /* the Sun */
   int  nump ;

   for (  nump = 1 ;  nump <= 11 ; nump++ )
     {              /* Gauss gravitational constant unforfun */
       factormus[nump] = sqr(0.01720209895)/systemofmasses[nump];
       factormuz[nump] = factormus[nump]; /* in au**3/day**2 */
     }
 }

 /* clcposvel is a void
   to obtain the position of the planet
      reffered to the barycentre from ephemeris */

 void clcposvel ( int  nplanet ,   /* input */
                  double  tintdb , /* input */
                  double  pos[4] ,
                  double  vel[4] ) /* output */
 {
   double  polquant[16],polquanu[16] ;
   double  coefquant [14][16] ;
   double  tn,tnn,t,r,w,rw,x,xw,xr,xv ;
   int  i,i1,i2,j,k,l,l0,m,n,np ;
   int  numcoeford[12] =
        { 0 , 2, 146, 182, 272, 302, 329, 353, 377, 395, 413, 701 } ;
   int  numbofcoef[12] =
        { 0 ,12,  12,  15,  10,   9,   8,   8,   6,   6,  12,  15 } ;
   int  numbofday[12]  =
        { 0,  8,  32,  16,  32,  32,  32,  32,  32,  32,   4,  32 } ;

   toreadephemeris(tintdb);

   k = numcoeford[nplanet];
   l = numbofcoef[nplanet];
   l0 = l-1;
   m = numbofday[nplanet];
   w = m;
   rw = 2.0/w;
   t = tintdb;
   tn = coefeph[0];
   r = (t-tn)/m;
   n = (int)(floor(r-1.0e-10));
   np = k+3*l*n-1;
   tnn = tn+m*n;
   x = -1.0+(t-tnn)*rw;
   xw = 2.0*x;
   for ( i = 1 ;  i <= 3 ; i++ )
     for ( j = 0 ; j <= l0 ; j++ )
       {
         np = np+1;
         coefquant[i][j] = coefeph[np-1];
       }
   polquant[0] = 1.0;
   polquant[1] = x;
   polquanu[0] = 1.0;
   polquanu[1] = xw;
   for (  i = 2 ;  i <= l ; i++ )
     {
       i1 = i-1;
       i2 = i-2 ;
       polquant[i] = xw*polquant[i1]-polquant[i2];
       polquanu[i] = xw*polquanu[i1]-polquanu[i2];
     }
   for (  i = 1 ;  i <= 3 ; i++ )
     {
       xr = coefquant[i][0];
       xv = 0.0;
       for (  j = 1 ;  j <= l0 ; j++ )
         {
           xr = xr+coefquant[i][j]*polquant[j];
           xv = xv+j*coefquant[i][j]*polquanu[j-1];
         }
       pos[i] = xr/1.49597870691e8 ;     /* position in AU */
       vel[i] = rw*xv/1.49597870691e8 ; /* velosity in AU/day */
     }
 }

 /* toopencoefile is a void
   to open file for ephemeris */

 int toopencoefile () /* all variables are external */
 {
   long pos ;
   int  from ;
   long ior , ire ;

   coebyte = 745*8 ; /* global from header unephjpl.h */

   coefile = open("..\\thouseph\\ephtheo.dat",
                  O_RDONLY|O_BINARY , S_IREAD) ;

   if  ( coefile == -1 )  return (-10); /* error to open file */

   /* file is opened for read */

   /* the first
      to read from the end of file */
   from = SEEK_END ;  /* End-of-file */
   pos = coebyte;      /* to readfrom the end of file */
   ior = lseek(coefile,-pos,from); /* before the finish point */
   if  ( ior == -1L ) return (-11); /* error with finish */
                            /* to read the last array */
   ire = _rtl_read(coefile,coefeph,coebyte);
   if  ( ire == 0 ) return (-12); /* error to read to finish */

   coefeph[0] = coefeph[0]-2400000.5; /* to mjd */
   tlasteph = coefeph[0]+32; /* the last moment in file */

   ibytemax = ior ; /* maximum offset in byte to read */

   /* the second to read from the start of file */
   from = SEEK_SET ;	/* File beginning */
   pos = 0;
   ior = lseek(coefile,pos,from); /* to the start point */
   if  ( ior == -1L ) return (-21); /* error with start point */
                            /* to read the first array */
   ire = _rtl_read(coefile,coefeph,coebyte);
   if  ( ire == 0 ) return (-22); /* error to read from start */

   coefeph[0] = coefeph[0]-2400000.5; /* to mjd */
   tiniteph = coefeph[0];   /* the first moment in file */

   nofbyte = pos; /* initial offset in byte start point */

   return (0); /* normal values */
 }

 /* to read file with the ephemeris data */

 void toreadephemeris ( double  tintdb )
 {
   long    ibyte ;
   double  r ;

   if  ( ( tiniteph <= tintdb ) && ( tintdb <= tlasteph ) )
       {
         r = (tintdb-tiniteph)/32.0e0;
         ibyte = coebyte*(long)(floor(r));
         if  ( ibyte > ibytemax )
            ibyte = ibytemax;
         if ( ibyte != nofbyte )
             {
               lseek(coefile,ibyte,SEEK_SET);
               _rtl_read(coefile,coefeph,coebyte);
               coefeph[0] = coefeph[0]-2400000.5; /* to mjd */
               nofbyte = ibyte;
             }
       }
  /* ephemeris has been read in massive  coefeph(745) */
 }

 /* clcephearthmoon is a void
   to obtain the position of the earth and the moon
      reffered to the barycenter of the solar system from ephemeris */

 void clcephearthmoon ( double  tintdb , /* input */
                        double  posearth[4] ,
                        double  velearth[4] , /* output */
                        double  posmoon[4] ,
                        double  velmoon[4] )  /* output */
 {
   int  i ;
   double posm[4],velm[4] ;
   double posbarem[4],velbarem[4] ;
   double coefmassratio= 0.012300034/1.012300034 ;

   clcposvel(10,tintdb,posm,velm); /* the Moon reffered to the Earth */

   clcposvel(3,tintdb,posbarem,velbarem); /* the Earth */

   for (  i = 1 ;  i <= 3 ; i++ )
     { /* reffered to the solar system barycentre */
       posearth[i] = posbarem[i]-coefmassratio*posm[i];
       velearth[i] = velbarem[i]-coefmassratio*velm[i];
       posmoon[i] = posearth[i]+posm[i];
       velmoon[i] = velearth[i]+velm[i];
     }
 }

 /* earths in tdb moment tb is a void
    to obtain the position of the earth reffered to the sun */

void earths ( double  tb ,           /*  intput */
              double  x[4] ,
              double  v[4] )  /* output */
{
  int i ;
  double psun[4],vsun[4] ;
  double posmoon[4],velmoon[4] ;
  double posbarem[4],velbarem[4] ;
  double coefmassratio= 0.012300034/1.012300034 ;

  clcposvel(11,tb,psun,vsun); /* the Sun */

  clcposvel(10,tb,posmoon,velmoon); /* the Moon */

  clcposvel(3,tb,posbarem,velbarem); /* the Earth */

  for (  i = 1 ;  i <= 3 ; i++ )
    {
      x[i] = posbarem[i]-coefmassratio*posmoon[i]-psun[i];
      v[i] = velbarem[i]-coefmassratio*velmoon[i]-vsun[i];
    }
}

