
 /* the forces due to planets, the moon, the sun
   the right hand side of differential equations */

/* unit unequras
   numberofplanets = 11
   nmercury  = 1
   nvenus    = 2
   nearth    = 3
   nmars     = 4
   njupiter  = 5
   nsaturn   = 6
   nuranus   = 7
   nneptune  = 8
   npluto    = 9
   nmoon     = 10
   nsun      = 11
*/

#include <math.h>

#include "unequras.h"

#include "unforfun.h"
#include "unfortim.h" /* voids transutctotdt transtdttotdb */

#include "unephjpl.h" /* to use planetary ephemeris clcposvel for example */

 /* in curp
   the position of the asteroid
   in the fixed equatorial system */


 void planetsforces ( double teph ,        /* input moment */
                      double curp[4] ,     /* input position */
                      double forcec[4] )   /* output forces */
 {
   int i,n ;
   double dr,sr ;
   double posp[12][4] ;
   double velp[12][4] ;
   double posa[4] ;

   /* the planets , the sun and the moon in j2000 system */
   for (  n = 1 ;  n <= 11 ; n++ )
     if  ( ( n != 3 ) && ( n != 10 ) ) /* the Earth the Moon */
                                   /* refer to the barycentre */
         clcposvel(n,teph,posp[n],velp[n]) ; /* for the planets */
       else
         if  ( n == 3 )           /* the Earth */
                     /* refer to the barycentre */
             clcephearthmoon(teph,posp[3],velp[3],
                                  posp[10],velp[10]);

                                                   /* sqr unforfun */
   dr = 1.0/sqrt(sqr(curp[1])+sqr(curp[2])+sqr(curp[3])); /* range */
   dr = -factormuz[11]*dr*dr*dr; /* minor planet refer to the Sun */

   for (  i = 1 ;  i <= 3 ; i++ )
     forcec[i] = curp[i]*dr; /* the sun main forces */
   for (  n = 1 ;  n <= 11 ; n++ )
     if  ( n != 11 )               /* but for the Sun forward */
       {
         for (  i = 1 ;  i <= 3 ; i++ )
           posa[i] = posp[n][i]-posp[11][i]; /* refer to the sun */
           dr = 1/sqrt(+sqr(posa[1]-curp[1])   /* for current planet */
                       +sqr(posa[2]-curp[2])   /* and the minor planet */
                       +sqr(posa[3]-curp[3])); /* 1/delta in km */

           dr = dr*dr*dr; /* 1/delta**3 */

           sr = 1/sqrt(sqr(posa[1])+sqr(posa[2])+sqr(posa[3])); /* 1/r */
           sr = sr*sr*sr; /* 1/r**3 */

           for (  i = 1 ;  i <= 3 ; i++ )
             forcec[i] = +forcec[i]
                         +factormuz[n]*(+(posa[i]-curp[i])*dr-posa[i]*sr);
       }
 }

 /* to calculate the forces due to all planets */


 void clcrighthandcoor ( double ut ,         /* input */
                         double rc[4] ,      /* input */
                         double force[4] )   /* output */
 {
   double td,dt,tb ; /* terrestrial time tt barycentric time tdb */

   transutctotdt(ut,&td,&dt); /* unit unfortim terrestrial time tt */
   transtdttotdb(td,&tb) ;    /* barycentric time tdb teph for ephemeris */
                               /* the forces */
   planetsforces(tb,rc,force); /* due to the sun the moon and the planets */

 }

