
/* unit unfordat  to change date between civil and julian forms */

#include <math.h>

#include "unforfun.h"
#include "unfordat.h"

 /* transdatetomjd is a void
   for transition in interval for two centuries
       from date in form  day month year  to  modified julian day */

 double fromdatetomjd ( int nday , int nmonth , int nyear ,
                        int nhour , int nminute , double second )
 {
   int    year ;
   int    j1,m1,ij,iq ;
   double t,q ;
 
   year = nyear;
   if ( year < 85 ) year = 2000+year;
   if  (year < 100 )  year = 1900+year;
   j1 = year-1900;
   m1 = nmonth-3;
   if ( m1 < 0 ) {  m1 = m1+12; j1 = j1-1;  }
   q = 0.5+30.6*m1;
   iq = q;
   ij = j1/4;
   q = iq+ij+nday;
   t = 15078.+365.*j1+q;
   t = t+(nhour+(nminute+second/60.0)/60.0)/24.0;
   return (t);
 }

 /* this is quite simple void
   to change a value for the part of day in second
        to the civil form :     hour minute second */

 void fromsecparttohourminsec ( double secpart ,
                                int *inthour , int *intmin ,
                                double *second )
 {
    double r  ;

    r = secpart/3600.0;
    *inthour = r;
    r = 60.0*frac(r);
    *intmin = r;
    *second = 60.0*frac(r);
    if  ( *second > 59.999 ){ *second = 0; *intmin = *intmin+1; }
    if  ( *intmin > 59 )
      { *intmin = *intmin-60; *inthour = *inthour+1; }
 }

 /* transmjdtodate is a void
   for transition in interval for two centuries
       from modified julian day to date in form  day month year */

 void transmjdtodate ( double tmjd ,
                       int *nday , int *nmonth , int *nyear ,
                       int *nhour , int *nminute ,
                       double *second )
 {
   long n,nz,nz1,n1,n2,m1 ;
   double du,r,z,z1,sp ;
   int  khour,kmin ;
   double sec ;

   z = tmjd; /* utc  */
   sp = 86400.0*frac(z);
   n = z;
   du =  n;
   r = du-15078.0;
   n = r;
   z = r/1461.01;
   nz = z;
   n1 = n-1461*nz;
   r = n1;
   z1 = r/365.25;
   nz1 = z1;
   *nyear = 4*nz+nz1+1900;
   if  ( n1 == 1461 )
     {
          *nmonth = 2;
          *nday = 29;
     }
     else
     {
          n2 = n1-365*nz1;
          r = n2;
          r = (r-0.5)/30.6;
          m1 = r;
          *nmonth = m1+3;
          n = 30.6*(*nmonth)-91.3;
          *nday = n2-n;
          if  ( *nmonth > 12 )
            {
                 *nmonth = *nmonth-12;
                 *nyear = *nyear+1;
            }
     }
   fromsecparttohourminsec(sp,&khour,&kmin,&sec);
   *nhour = khour ;
   *nminute = kmin ;
   *second = sec ;
 }
