
 /* for the simple mathematical functions */

#include <math.h>

#include "unforfun.h"


 double sqr ( double a )
 {
  return (a*a);
 }

 double frac ( double a )
 {
   return (fmod(a,1.0));
 }

 /* datan2 is a function
   to obtain arctan for the angle in interval
      from  0  to  +2*pi  in rad */

 double  datan2 ( double sa , double ca )
 {
   return (atan2(sa,ca));
 }

 /* atandegree is a function  to obtain
   arctan for the angle in interval from  0  to  360  in degree */

 double  atandegree ( double s , double c )
 {
   double a;

   a = 180.0/M_PI*datan2(s,c); /* in degree */
   if  ( a < 0 )  a = 360+a;
   return(a);
 }

 double  scalarmult ( double a[4] , double b[4] )
 {
  return(a[1]*b[1]+a[2]*b[2]+a[3]*b[3]);
 }

 /* void to fill the elements of the simple rotation matrix */

 void forrotmatr ( int iaxis , double angle , double matr[4][4] )
 {
   int    i,j;
   double s,c;

   c = cos(angle);
   s = sin(angle);
   for (  i = 1 ;  i <= 3 ; i++ )
     for (  j = 1 ;  j <= 3 ; j++ )
     {
       if  ( i == j )
          matr[i][j] = 1.0;
         else
           matr[i][j] = 0.0; /* unit matrix */
     }
   switch ( iaxis )
   {
     case 1 :
         { /* rotate around ox axis */
           matr[2][2] = +c;
           matr[2][3] = +s;
           matr[3][2] = -s;
           matr[3][3] = +c;
           break;
         }
     case 2 :
         { /* rotate around oy axis */
           matr[1][1] = +c;
           matr[1][3] = -s;
           matr[3][1] = +s;
           matr[3][3] = +c;
           break;
         }
     case 3 :
         { /* rotate around oz axis */
           matr[1][1] = +c;
           matr[1][2] = +s;
           matr[2][1] = -s;
           matr[2][2] = +c;
           break;
         }
   } /* case for axis of rotation */
 }

 /* void to multiple to simple 3*3 matrix */

 void tomultmatr ( double ma[4][4] , double mb[4][4] , double mc[4][4] )
 {
   int i,j,k;

   for (  i = 1 ;  i <= 3 ; i++ )
     for (  j = 1 ;  j <= 3 ; j++ )
       {
         mc[i][j] = 0.0;
         for (  k = 1 ;  k <= 3 ; k++ )
           mc[i][j] = mc[i][j]+ma[i][k]*mb[k][j];
       }
 }

 void multmatrvec ( double p[4][4] , double v[4] , double vp[4] )
 {
   int i,j;

   for (  i = 1 ;  i <= 3 ; i++ )
     {
       vp[i] = 0.0;
       for (  j = 1 ;  j <= 3 ; j++ )
         vp[i] = vp[i]+p[i][j]*v[j];
     }
 }

 void transpmatr ( double ma[4][4] , double mb[4][4] )
 {
   int i,j;

   for (  i = 1 ;  i <= 3 ; i++ )
     for (  j = 1 ;  j <= 3 ; j++ )
       mb[i][j] = ma[j][i];
 }

