
 /* unit unforpnm  for matrix precessin nutation */

#include <math.h>

#include "unforpnm.h"

#include "unforfun.h"  /* void forrotmatr(iaxis,angle,matr) angle radian */

 void clcprecangles ( double epoch , double tmjd ,
                      double *dzita0 , double *teta , double *zet )
 {
   double de,de2,dt,dt2,dt3,r ;

   de = (epoch-51544.5)/36525.0; /* in century */
   de2 = de*de;
   dt = (tmjd-epoch)/36525.0;    /* in century */
   dt2 = dt*dt;
   dt3 = dt2*dt;
   r = (2306.2181+1.39656*de-0.000139*de2)*dt; /* in second of arc */
   *dzita0 = r+(0.30188-0.000344*de)*dt2+0.017998*dt3;
   *teta = (2004.3109-0.85330*de-0.000217*de2)*dt
          -(0.42665+0.000217*de)*dt2-0.041833*dt3;
   *zet = r+(1.09468+0.000066*de)*dt2+0.018203*dt3;
 }

  /* clcprecmatr is a void
    to calculate the matrix of precession
       for change from   epoch  to  tmjd  or another ints
       from the fixed equator and ecliptic to the instantaneous ones.
       fundamental  epoch  is  J2000.0
         but  epoch  as parameter
              may be any fixed epoch in  mjd
                 and  tmjd  is epoch of the date in  mjd .
       precmatr[1..3,1..3] is the resulting massive .
       global const - secrad - for change from arcsec to radians . */

 void clcprecmatr ( double epoch , double tmjd , double precmatr[4][4] )
 {
   double dzita0,teta,zet ;
   double aa[4][4],ab[4][4],ac[4][4],am[4][4] ;
   double secrad = M_PI/(180.0*3600.0) ;

    clcprecangles(epoch,tmjd,&dzita0,&teta,&zet); /* angles in arcsec */
    forrotmatr(3,-secrad*dzita0,aa); /* void from unforfun */
    forrotmatr(2,secrad*teta,ab);    /* void for rotation */
    forrotmatr(3,-secrad*zet,ac);
    tomultmatr(ab,aa,am); /* void from unforfun */
    tomultmatr(ac,am,precmatr); /* this is our result */
 }

 void clcnutmatr ( double deltapsi , double deltaeps , double epsmean ,
                   double matrnut[4][4] )
 {
   double matreps[4][4],matrpsi[4][4],matrcur[4][4] ;

   forrotmatr(1,epsmean,matreps);   /* void from unforfun */
   forrotmatr(3,-deltapsi,matrpsi); /* matrix of rotation */
   tomultmatr(matrpsi,matreps,matrcur); /* void from unforfun */
   forrotmatr(1,-epsmean-deltaeps,matreps);
   tomultmatr(matreps,matrcur,matrnut); /* this is our result */
 }

