
 /* unit unforrom simple matrix of transformations */

#include "unforfun.h" /* for voids forrotmatr , transpmatr */
#include "unfortim.h" /* transutctotdt for example */
#include "unfornut.h" /* function togetepsmean void clcnut */
#include "unforpnm.h" /* voids clcprecmatr clcnutmatr */
#include "unforrom.h"

 /* tc - moment in scale tdb in modified julian day
   pf - matrix to transform from mean equator to standard equator */

 void frommeantofixequm ( double tc , double pf[4][4] )
 {
   double prm[4][4] ;

   clcprecmatr(51544.5,tc,prm); /* unforpnm const from uncontyp */
   transpmatr(prm,pf);          /* unforfun */
 }

 /* tc - moment in scale tdb in modified julian day
   pn - matrix to transform from standard equator to true equator */

 void fromfixtotrueequm ( double tc , double pn[4][4] )
 {
   double dpsi,deps ;
   double prec[4][4],nutm[4][4];

   clcprecmatr(51544.5,tc,prec); /* unforpnm precession matrix */
   clcnut(tc,&dpsi,&deps) ;  /* obliquity radian unfornut */
   clcnutmatr(dpsi,deps,togetepsmean(tc),nutm); /* unforpnm unfornut */
   tomultmatr(nutm,prec,pn); /* from fixed to true equator */
 }

 /* tc - moment in scale tdb in modified julian day
   pn - matrix to transform from true equator to standard equator */

 void fromtruetofixequm ( double tc , double pn[4][4] )
 {
   double pun[4][4] ;

   fromfixtotrueequm(tc,pun); /* matrix from fixed to true equator */
   transpmatr(pun,pn);        /* to transponir unforfun */
 }

 /* tc  - moment in scale utc in modified julian day
   ptm - matrix to transform from standard equator to terrestrial system */

 void fromfixtoterram ( double utc , double dut ,
                        double *tdb ,double ptm[4][4] )
 {
   double dt,td,dbu ;
   double pn[4][4],pz[4][4] ;

   transutctotdt(utc,&td,&dt);  /* proc from unfortim terrestrial time */
   transtdttotdb(td,&dbu);     /* proc from unfortim ephemeris time tdb */
   *tdb = dbu ;
   earthrotmatr(utc,dut,pz);  /* proc from unforsit rotation matrix  */
   fromfixtotrueequm(dbu,pn); /* matrix from fixed  to true  equator */
   tomultmatr(pz,pn,ptm);     /* unforfun m. fixed  to terra system  */
 }

 /* ptm - matrix to transform from standard equator to terrestrial system
   pzm - matrix to transform from terrestrial system to standard equator */

 void fromterratofixm ( double ptm[4][4] , double  pzm[4][4] )
 {
   transpmatr(ptm,pzm); /* from unforfun */
 }

