
 /* unit unforsit for greenwich sidereal time functions */
#include <math.h>

#include "unforsit.h"
#include "unforfun.h"  /* for void forrotmatr */
#include "unfortim.h" /* for void transutctotdt */
#include "unfornut.h" /* for function togetepsmean void clcnut */

 /* togetgmstime is a function
   to obtain greenwich mean sidereal time in radians .
      iau 1976  for the greenwich mean sidereal time .
      tinutc in utc and close to ut1 */

 double  togetgmstime( double tinutc , double deltaut )
 {
   double t,aj,ajj,ajs,s,s0,r,freq ;
   double sidtime ;
   long i,iaj ;
   double pi22 = 2*M_PI ;

   t = tinutc+deltaut/86400.0;
   iaj = t ;
   aj = iaj;
   s = t-aj;
   ajj = aj-51544.5;
   ajs = ajj/36525.0;
   s0 = 1.753368559233266e0+(628.3319706888409e0
	+(6.770713944903336e-06-4.508767234318685e-10*ajs)*ajs)*ajs;
   freq = 1.002737909350795e0
	+(5.900575455674703e-11-5.893984333409384e-15*ajs)*ajs;
   s0 = s0+freq*s*pi22;
   r = s0/pi22;
   i = r;
   sidtime = s0-pi22*i;
   if  ( sidtime < 0 ) sidtime = sidtime+pi22;
   return (sidtime);
 }

 double  togetgastime ( double tinutc , double deltaut )
 {
   double t,td,du,dt,dp,de,eps ;

   t = tinutc;
   du = deltaut;
   transutctotdt(t,&td,&dt); /* from unfortim to terrestrial time */
   eps = togetepsmean(td); /* function from unfornut epsilon in radian */
   clcnut(td,&dp,&de); /* from unfornut nutation parameters in radian*/
   return (togetgmstime(t,du)+dp*cos(eps));
 }

 void earthrotmatr ( double utc , double dut ,  double rz[4][4] )
 {
   double gast ;

   gast = togetgastime(utc,dut);
   forrotmatr(3,gast,rz);
 }

