
/* unit unfortim  only for special satellite case */

#include <math.h>
#include "unfortim.h"

 /*  transutctotdt is a void for transition  utc  to  tdt .*/

 void transutctotdt( double tinutc , double *tintdt , double *deltata )
 {
   int i ;
 double
     tabl[15][2] =
    {{44239.0, 51.184 },       /*  1980 01 01  */
     {44786.0, 52.184 },       /*  1981 07 01  */
     {45151.0, 53.184 },       /*  1982 07 01  */
     {45516.0, 54.184 },       /*  1983 07 01  */
     {46247.0, 55.184 },       /*  1985 07 01  */
     {47161.0, 56.184 },       /*  1988 01 01  */
     {47892.0, 57.184 },       /*  1990 01 01  */
     {48257.0, 58.184 },       /*  1991 01 01  */
     {48804.0, 59.184 },       /*  1992 07 01  */
     {49169.0, 60.184 },       /*  1993 07 01  */
     {49534.0, 61.184 },       /*  1994 07 01  */
     {50083.0, 62.184 },       /*  1996 01 01  */
     {50630.0, 63.184 },       /*  1997 07 01  */
     {51178.0, 64.184 },       /*  1999 01 01  */
     {53736.0, 65.184 }};      /*  2006 01 01  */

   *tintdt = tinutc;
   *deltata = 0.0;
   for (  i = 0 ;  i <= 14 ; i++ )
    {
     if ( tabl[i][0] <= tinutc )
      {
       if ( tinutc < tabl[i+1][0] )
         *deltata = tabl[i][1]/86400.e0;
      }
    }
   if  ( tinutc > tabl[14][0] )
     *deltata = tabl[14][1]/86400.0;
   *tintdt = tinutc+*deltata;
 }

 /* transtdttotdb is a void
   to obtain the moment in  tdb  with the use a value for  tdt */

 void transtdttotdb( double tintdt , double *tintdb )
 {
   double d,g ;

   d = (tintdt-51544.5)/36525.e0;
   g = (M_PI/180.0)*(357.528+35999.050*d);
   *tintdb = tintdt+(0.001658*sin(g+0.0167*sin(g)))/86400.e0;
 }

