/* unit unjob055  earth rotation matrix*/

#include <math.h>
#include <conio.h>
#include <stdio.h>

#include "unjob055.h"
#include "unfordat.h" /* for fromdatetomjd function */
#include "unfornut.h" /* for togetepsmean function clcnut void */
#include "unfortim.h" /* for transutctotdt void */
#include "unforsit.h"

void forjob055 ()
{
  int nd,nm,ny ;  /* day month year */
  int kh,km ;  /* hour minute */
  double sec ; /* second */
  double delut,dt  ; /* ut1-utc in second of time */
  double utc,gmst ; /* utc moment in modified julian day */
  double ep,dp,de ; /* nutation parameters */
  double tdt,gast ; /* greenwich true sidereal time */
  double p[4][4] ;
  double radsec = ( 3600.0*180.0/M_PI ) ;

  printf("\n");
  printf("  earth rotation matrix\n");
  nd = 7;
  nm = 12;
  ny = 1999;
  kh = 5;
  km = 45;
  sec = 0.0;
  delut = 0.38415; /* ut1-utc in second of time */
  utc = fromdatetomjd(nd,nm,ny,kh,km,sec); /* unfordat */
  gmst = togetgmstime(utc,delut);
  transutctotdt(utc,&tdt,&dt); /* from unfortim for terrestrial time */
  ep = togetepsmean(tdt); /* mean obliquity */
  clcnut(tdt,&dp,&de);     /* nutation parameters */
  gast = togetgastime(utc,delut);
  earthrotmatr(utc,delut,p);
  printf("  input\n");
  printf("  moscow decret winter time\n");
  printf("  %10i      day\n",nd);
  printf("  %10i      month\n",nm);
  printf("  %10i      year\n",ny);
  printf("  %10i      hour\n",kh);
  printf("  %10i      minute\n",km);
  printf("  %14.3f  second\n",sec);
  printf("  universal time correction ut1-utc\n");
  printf("  %14.3f  second of time\n",delut);
  printf("  output\n");
  printf("  moment in modified julian day\n");
  printf("  %19.8f  day with part in utc scale\n",utc);
  printf("  moment in terrestrial time scale\n");
  printf("  %19.8f  day with part in tt scale\n",tdt);
  printf("  %19.3f  obliquity in second of arc\n",radsec*ep);
  printf("  %19.3f  d(psi)    in second of arc\n",radsec*dp);
  printf("  greenwich mean sidereal time\n");
  printf("  %19.12f  in radian\n",gmst);
  printf("  greenwich true sidereal time\n");
  printf("  %19.12f  in radian\n",gast);
  printf("  earth rotation matrix\n");
  printf("  %19.12f%19.12f%19.12f\n",p[1][1],p[1][2],p[1][3]);
  printf("  %19.12f%19.12f%19.12f\n",p[2][1],p[2][2],p[2][3]);
  printf("  %19.12f%19.12f%19.12f\n",p[3][1],p[3][2],p[3][3]);
}
