/* unit unjob065 from terrestrial to celestial system */

#include <conio.h>
#include <stdio.h>

#include "unjob065.h"
#include "unfordat.h"  /* for fromdatetomjd function */
#include "unfornut.h"  /* for togetepsmean function clcnut void */
#include "unfortim.h"  /* for transutctotdt void */
#include "unforrom.h"  /* for fromfixtoterram void */

void forjob065 ()
{
  int nd,nm,ny ;  /* day month year */
  int kh,km ;  /* hour minute */
  double sec,teph ; /* second , moment tdb scale */
  double delut,dt ; /* ut1-utc in second of time */
  double utc,gmst ; /* utc moment in modified julian day */
  double dp,de ; /* nutation parameters */
  double tdt,gast ; /* greenwich true sidereal time */
  double p[4][4],a[4][4] ;  /* type from uncontyp */

  printf("\n");
  printf("  from terrestrial to celestial system\n");
  nd = 7;
  nm = 12;
  ny = 1999;
  kh = 5;
  km = 45;
  sec = 0.0;
  delut = 0.38415; /* ut1-utc in second of time */
  utc = fromdatetomjd(nd,nm,ny,kh,km,sec); /* unfordat */
  gmst = togetgmstime(utc,delut);
  transutctotdt(utc,&tdt,&dt); /* from unfortim for terrestrial time */
  transtdttotdb(tdt,&teph);   /* from unfortim for ephemeris time */
  clcnut(teph,&dp,&de);     /* nutation parameters */
  gast = togetgastime(utc,delut);
  fromfixtoterram(utc,delut,&teph,p);  /* unforrom */
  fromterratofixm(p,a);          /* unforrom to transponir */
  printf("  input\n");
  printf("  moment in modified julian day\n");
  printf("  %19.8f  day with part in utc scale\n",utc);
  printf("  universal time correction ut1-utc\n");
  printf("  %14.3f  second of time\n",delut);
  printf("  moment in terrestrial time scale\n");
  printf("  %19.8f  day with part in tt scale\n",tdt);
  printf("  moment in ephemeris time scale\n");
  printf("  %19.8f  day with part in tdb scale\n",teph);
  printf("  greenwich mean sidereal time\n");
  printf("  %19.12f  in radian\n",gmst);
  printf("  greenwich true sidereal time\n");
  printf("  %19.12f  in radian\n",gast);
  printf("  from celestial to terrestrial system matrix\n");
  printf("  %19.12f%19.12f%19.12f\n",p[1][1],p[1][2],p[1][3]);
  printf("  %19.12f%19.12f%19.12f\n",p[2][1],p[2][2],p[2][3]);
  printf("  %19.12f%19.12f%19.12f\n",p[3][1],p[3][2],p[3][3]);
  printf("  output\n");
  printf("  from terrestrial to celestial system matrix\n");
  printf("  %19.12f%19.12f%19.12f\n",a[1][1],a[1][2],a[1][3]);
  printf("  %19.12f%19.12f%19.12f\n",a[2][1],a[2][2],a[2][3]);
  printf("  %19.12f%19.12f%19.12f\n",a[3][1],a[3][2],a[3][3]);
}
