
/* unit unjob121 to test unit unforkep with kepler elements */

#include <math.h>
#include <conio.h>
#include <stdio.h>

#include "unjob121.h"

#include "unforkep.h"

void forjob121 ()
{
  double start,finish ;      /* moment in mjd */
  double pose[4],ange[4] ;   /* kepler elements */
  double posk[4],angk[4] ;   /* kepler elements */
  double vecr[4],vecv[4] ;   /* rectangular position velosity */

  start  = 53000.0 ;         /* epoch of the elements in mjd */

  finish = start + 1000.0 ;  /* moment for the result */
                          /* ecliptic heliocentric */
  pose[1] =  1.91997795;  /* semi-major axis AU */
  pose[2] =  0.43460482;  /* eccentricity */
  pose[3] = 11.878789;    /* inclination in degree */

  ange[1] =171.418697;    /* the ascending node in degree */
  ange[2] = 26.433709;    /* argument of perigei in degree */
  ange[3] =335.308176;    /* mean anomaly in degree */

  fromkeplertocart(start,pose,ange,finish,vecr,vecv); /* from unforkep */

  fromcarttokepler(finish,vecr,vecv,start,posk,angk);

  printf(" \n");
  printf("   initial elements ecliptic heliocentric\n");
  printf("   minor body  Amor 1221\n");
  printf("   %19.8f  epoch in mjd         \n",start);
  printf("   %19.8f  a semimajor axis   AU\n",pose[1]);
  printf("   %19.8f  e eccentricity       \n",pose[2]);
  printf("   %19.6f  i inclination degree \n",pose[3]);
  printf("   %19.6f  O ascending node deg.\n",ange[1]);
  printf("   %19.6f  o arg.perihelium deg.\n",ange[2]);
  printf("   %19.6f  M mean anomaly degree\n",ange[3]);

  printf(" \n");
  printf("   coordinate and velosity equator heliocentric\n");
  printf("   %19.8f  moment in mjd        \n",finish);
  printf("   %19.9f  x  coordinate   in AU\n",vecr[1]);
  printf("   %19.9f  y  coordinate   in AU\n",vecr[2]);
  printf("   %19.9f  z  coordinate   in AU\n",vecr[3]);
  printf("   %19.12f  vx velosity in AU/day\n",vecv[1]);
  printf("   %19.12f  vy velosity in AU/day\n",vecv[2]);
  printf("   %19.12f  vz velosity in AU/day\n",vecv[3]);

  printf(" \n");
  printf("   the same elements ecliptic heliocentric\n");
  printf("   %19.8f  epoch in mjd         \n",start);
  printf("   %19.8f  a semimajor axis   AU\n",posk[1]);
  printf("   %19.8f  e eccentricity       \n",posk[2]);
  printf("   %19.6f  i inclination degree \n",posk[3]);
  printf("   %19.6f  O ascending node deg.\n",angk[1]);
  printf("   %19.6f  o arg.perihelium deg.\n",angk[2]);
  printf("   %19.6f  M mean anomaly degree\n",angk[3]);

}