
/* unit unjob136
   to integrate orbit with random errors
      by using simple procedures from unit unrandas  */

#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <io.h>

#include "unjob136.h"
#include "unrandas.h"

void forjob136 ()
{
  int numvar ; /* number of random variant for elements */

  double elepo ;             /* epoch of the elements in mjd */
  double pose[4],ange[4] ;   /* kepler elements initial */
  double spos[4],sang[4] ;   /* kepler elements standard deviation */

  double  finish ;      /* moments in mjd for results */

  double  difstart[4],difinish[4] ; /* result ellipse start finish */

  printf("\n");
  printf("to integrate some orbits with random errors\n");

  /* initial conditions minor body 2024 HW*/

  elepo  = 54200.0 ;      /* epoch of the elements in mjd */

                          /* ecliptic heliocentric Apophis */

  pose[1] =  2.68853397;  /* semi-major axis AU */
  pose[2] =  0.63697171;  /* eccentricity */
  pose[3] =    0.832927;  /* inclination in degree */

  ange[1] =  220.429649;  /* the ascending node in degree */
  ange[2] =   62.299241;  /* argument of perigei in degree */
  ange[3] =  234.614931;  /* mean anomaly in degree */

  /* standard deviation for Kepler elements */

  spos[1] =  0.00001000;  /* sigma semi-major axis AU */
  spos[2] =  0.00000100;  /* sigma eccentricity */
  spos[3] =    0.000100;  /* sigma inclination in degree */

  sang[1] =    0.000100;  /* sigma the ascending node in degree */
  sang[2] =    0.000100;  /* sigma argument of perigei in degree */
  sang[3] =    0.000100;  /* sigma mean anomaly in degree */

  finish = elepo + 365.25 ;   /* moment for the result */

  numvar = 25 ;  /* number of random variant */

  printf(" \n");
  printf("   minor body 2024 HW\n");
  printf("   elements ecliptic heliocentric and standard deviation\n");
  printf("%15.2f  epoch in mjd         \n",elepo);
  printf("%15.8f %12.8f   a semimajor axis   AU\n",pose[1],spos[1]);
  printf("%15.8f %12.8f   e eccentricity       \n",pose[2],spos[2]);
  printf("%15.6f %12.6f   i inclination degree \n",pose[3],spos[3]);
  printf("%15.6f %12.6f   O ascending node deg.\n",ange[1],sang[1]);
  printf("%15.6f %12.6f   o arg.perihelium deg.\n",ange[2],sang[2]);
  printf("%15.6f %12.6f   M mean anomaly degree\n",ange[3],sang[3]);

  printf(" \n");
  printf("   %5i  number of variants\n",numvar);

  errellipse(numvar,
             elepo,pose,ange,spos,sang,
             finish,
             difstart,difinish); /* unrandas void */

  printf(" \n");
  printf("       epoch         dx(AU)       dy(AU)       dz(AU)\n");
  printf("%12.2f %14.8f %12.8f %12.8f  start  \n",
         elepo,difstart[1],difstart[2],difstart[3]);  /* error start */
  printf("%12.2f %14.8f %12.8f %12.8f  finish \n",
         finish,difinish[1],difinish[2],difinish[3]); /* error finish */

}
